% close all
% clear all
% clc
% 


%  state space model 

A=[0 1;0 0];




B=[0;1];


Q = diag([10, 1]);  %  higher importance to position tracking
R = eye(1);  % equal importance to all control inputs



% [K,S,P] = lqr(A,B,Q,R,0);
% 
% A_bar=A-B*K;

K=[10 0.5];
A_bar=A-B*K;

I = eye(size(A_bar,2)); % pos.def matrix
% A_bar' * P + P * A_bar + I = 0
P = lyap(A_bar, 2*I);%!!
Pw=P;


G=-inv(B'*B)*B'*(A-B*K)*[1;0];


X(:,1)=X0;% the initial states, change to rand


% the initial guess for the applied reference
v(:,1)=[X(1,1)];% the same as the initial position

%target location
goal_pt=[1.1];




mu=norm(-inv(A-B*K)*B*G);

c=[-1;0]; % 0.8-cp>=0, y<=0.8
d=1;


zeta=0.045;% the distance from the constraaint for which the repulsive force effect begins
delta=0.04; % the distance from the constraint from where the tightned constraint exists, and the repulsive force ...
% factor becomes equal to 1 

% Pw=sdpvar(6,6,'symmetric');
smoothing_factor=0.01; 

lambda=10; % smoothing factor 2

dt = 0.001;    % Time step (seconds)

time = 0:dt:50; %simulation time


count=1; %defined for the computation of the applied reference every 0.083 sec
dt_v=0.1; % update the applied reference every dt_v sec

% Simulation Loop
for i = 1:length(time)
    % calculate error

    Xv(:,i)=[v(1,count); 0];


    


    if rem(time(i),dt_v)==0 % the applied reference update every 0.083 sec

     

    gamma=((c'*Xv(:,i)+d)^2)/(c'*inv(Pw)*c);

    Lyapunov=double((X(:,i)-Xv(:,i))'*Pw*(X(:,i)-Xv(:,i)));

    % DSM=max(gamma-Lyapunov,0);

    DSM=max(gamma-Lyapunov,0);

    rho_a=(goal_pt-v(1,count))/max(norm(goal_pt-v(1,count)),smoothing_factor);

    rho_r= max(0, (zeta - c' * Xv(:,i) - d) / (zeta - delta)) * c(1) / norm(c(1));


    Attraction_Field=rho_a+rho_r;

    g=DSM*Attraction_Field;
    
    vartheta=c'*Xv(:,i)+d-delta; % the distance of the current equilibruim point from the virtual constraint
    
    %% Mu'taz Method
    % kappa=vartheta/(mu*dt_v*max(norm(g),lambda)); %dynamic kappa

    %% Other
    kappa=5;

 

    vdot=kappa*g;

    v(:,count+1)=v(:,count)+vdot*dt_v; % the applied reference update

    count=count+1;
    end


    % G=(-(A-B*K)\B)*Xv(1:3,i)\v(:,i);
    % G=1;

    u(:,i)=-K*X(:,i)+G*v(1,count);
    % Update State Using State Space Model
    x_dot(:,i) = A * X(:,i) + B * u(:,i);
    X(:,i+1) = X(:,i) + x_dot(:,i) * dt;



end


flag1=0;
for i=1:size(X,2)
if X(1,i)>1
flag1=1;
end
end

flag2=0;
for i=1:size(v,2)
if v(1,i)>0.96
flag2=1;
end
end



performance1=0;
for i=1:size(v,2)
performance1=performance1+norm(v(:,i)-[goal_pt;0]);
end

performance2=0;
for i=1:size(X,2)
performance2=performance2+norm(X(:,i)-[goal_pt;0]);
end
