% close all
% clear all
% clc
% 


%  state space model 

A=[0 1;0 0];




B=[0;1];



K=[10 0.5];
A_bar=A-B*K;

I = eye(size(A_bar,2)); % pos.def matrix
% A_bar' * P + P * A_bar + I = 0
P = lyap(A_bar, 2*I);% $$$$$$$
Pw=P; 

m_1=min(eig(P));
m_2=max(eig(P));


G=-inv(B'*B)*B'*(A-B*K)*[1;0];


X1(:,1)=X0;% the initial states


% the initial guess for the applied reference
v0=[X1(1,1)];% the same as the initial position 
%target location
goal_pt=[1.1];




mu=norm(-inv(A-B*K)*B*G);

c=[-1;0]; % d-cp>=0, x<=d
d=1;


zeta=0.045;% the distance from the constraint for which the repulsive force effect begins
delta=0.04; % the distance from the constraint from where the tightned constraint exists, and the repulsive force ...
% factor becomes equal to 1 


smoothing_factor=0.01; 

lambda=0.01; % smoothing factor 2

dt = 0.0001;    % Time step (seconds)

time = 0:dt:50; %simulation time


count=1; %defined for the computation of the applied reference every dt_v sec
dt_v=0.1; % update the applied reference every dt_v sec

% Simulation Loop
for i = 1:length(time)
    % calculate error

  


    % v_plot(:,i)=v(:,count); %to plot v vs time



    if rem(time(i),dt_v)==0 % the applied reference update every dt_v sec

    if i==1
        gamma=((c'*[v0;0]+d)^2)/(c'*inv(Pw)*c);
        DSM=max(gamma,0); 
        rho_a=(goal_pt-v0)/max(norm(goal_pt-v0),smoothing_factor);
        rho_r= max(0, (zeta - c' *[v0;0]- d) / (zeta - delta)) * c(1) / norm(c(1));
        Attraction_Field=rho_a+rho_r;
        g=DSM*Attraction_Field;
        vartheta=c'*[v0;0]+d-delta; % the distance of the current equilibruim point from the virtual constraint
        kappa(i)=(sqrt(m_1)/(sqrt(m_1)+sqrt(m_2)))*vartheta/(mu*dt_v*max(norm(g),lambda)); %dynamic kappa
       vdot=kappa(i)*g;
       v1(:,i)=v0+vdot*dt_v; % the applied reference update
       u(:,i)=-K*X1(:,i)+G*v1(i);
    else
         gamma=((c'*[v1(i-1);0]+d)^2)/(c'*inv(Pw)*c);

        Lyapunov=double((X1(:,i)-[v1(i-1);0])'*Pw*(X1(:,i)-[v1(i-1);0]));
        DSM=max(gamma-Lyapunov,0);
        rho_a=(goal_pt-v1(i-1))/max(norm(goal_pt-v1(i-1)),smoothing_factor);

    rho_r= max(0, (zeta - c' * [v1(i-1);0] - d) / (zeta - delta)) * c(1) / norm(c(1));



    Attraction_Field=rho_a+rho_r;

    g=DSM*Attraction_Field;
    
    vartheta=c'*[v1(i-1);0]+d-delta;
    kappa(i)=max(((sqrt(m_1)/(sqrt(m_1)+sqrt(m_2)))*vartheta-(sqrt(m_2)/(sqrt(m_1)+sqrt(m_2)))*(norm(X1(:,i)-[v1(i-1);0])))/(mu*dt_v*max(norm(g),lambda)),0); %dynamic kappa

    vdot=kappa(i)*g;

    v1(i)=v1(i-1)+vdot*dt_v; % the applied reference update
     u(:,i)=-K*X1(:,i)+G*v1(i);
    end
    
    else
        v1(i)=v1(i-1);
        kappa(i)=kappa(i-1);
        u(:,i)=-K*X1(:,i)+G*v1(i);

    end
    % Update State Using State Space Model
    x_dot(:,i) = A * X1(:,i) + B * u(:,i);
    X1(:,i+1) = X1(:,i) + x_dot(:,i) * dt;



end


flag1=0;
for i=1:size(X1,2)
if X1(1,i)>1
flag1=1;
end
end

flag2=0;
for i=1:size(v1,2)
if v1(1,i)>0.96
flag2=1;
end
end



performance1=0;
for i=1:size(v1,2)
performance1=performance1+norm(v1(:,i)-[goal_pt;0]);
end

performance2=0;
for i=1:size(X1,2)
performance2=performance2+norm(X1(:,i)-[goal_pt;0]);
end



% 
% v1=[v0,v1(1:end-1)];
% plot(time,X1(1,1:end-1), 'LineWidth', 1)
% hold on 
% plot(time,v1, 'LineWidth', 1)
% plot(time,kappa)